ファイルタイプに応じてファイルをフォルダに分類する

ファイルタイプに応じてファイルをフォルダに分類する

復旧したデータは約 2.8 TB (そうです、テラバイト) あり、重複がないかスキャンされますが、これらのファイルが存在するマシンはかなり古く、メモリは 2 GB しかありません (ただし、LVM では問題なく動作します)。そのため、重複スキャンを実行するのは困難を極めます。

私の質問は、ファイルタイプのリストを指定せずに、Debian でファイルをそのファイルタイプのフォルダーに移動し、必要に応じて自動的に名前を変更するにはどうすればよいかということです。

約 800 GB の空き容量があるので、データにこれを自由に使用させる前にいくつかテストを行うことができます。

答え1

Stephen のコードをスクリプトにラップし、パイプを少し改良しました。

#!/bin/bash 
set -e 
set -u 
set -o pipefail

start=$SECONDS

exts=$(ls -dp *.*| grep -v / | sed 's/^.*\.//' | sort -u) # not folders
ignore=""

while getopts ':f::i:h' flag; do
  case "$flag" in
    h)
        echo "This script sorts files from the current dir into folders of the same file type. Specific file types can be specified using -f."
        echo "flags:"
        echo '-f (string file types to sort e.g. -f "pdf csv mp3")'
        echo '-i (string file types to ignore e.g. -i "pdf")'
        exit 1
        ;;
    f)
        exts=$OPTARG;;
    i)
        ignore=$OPTARG;;
    :) 
        echo "Missing option argument for -$OPTARG" >&2; 
        exit 1;;
    \?)
        echo "Invalid option: -$OPTARG" >&2
        exit 1
        ;;
  esac
done

for ext in $exts 
do  
    if [[ " ${ignore} " == *" ${ext} "* ]]; then
        echo "Skiping ${ext}"
        continue
    fi
    echo Processing "$ext"
    mkdir -p "$ext"
    mv -vn *."$ext" "$ext"/
done

duration=$(( SECONDS - start ))
echo "--- Completed in $duration seconds ---"

答え2

次のようなディレクトリで

$ ls   
another.doc  file.txt  file1.mp3  myfile.txt

次のコマンドを使用して、ファイル拡張子のリストを作成できます。

$ exts=$(ls | sed 's/^.*\.//' | sort -u)

次に、これらの拡張機能をループして、ファイルをサブディレクトリに移動します。

$ for ext in $exts
> do
> echo Processing $ext
> mkdir $ext
> mv -v *.$ext $ext/
> done

これを実行すると、次の出力が得られます。

Processing doc
'another.doc' -> 'doc/another.doc'
Processing mp3
'file1.mp3' -> 'mp3/file1.mp3'
Processing txt
'file.txt' -> 'txt/file.txt'
'myfile.txt' -> 'txt/myfile.txt'

結果:

$ ls
doc/  mp3/  txt/

$ ls *
doc:
another.doc

mp3:
file1.mp3

txt:
file.txt  myfile.txt

関連情報